﻿module Parser

open FParsec
open LambdaCalculus

let ws = spaces
let strws st = pstring st .>> ws

let identifier = many1SatisfyL (isNoneOf ".\() \t\r\n") "identifier" .>> ws

let variable = identifier |>> Variable

let term, termref = createParserForwardedToRef<Term, unit>()

let lambda = (strws "\\" >>. identifier .>> strws ".") .>>. ((term .>> ws) <?> "function body")
            |>> Lambda

let atom = variable <|> between (strws "(") (strws ")") term
let applications = many1 atom |>> List.reduce (fun a b -> Application(a,b))

termref := (lambda <|> applications) <?> "term"

let fullTerm = ws >>. term .>> eof
